from ariadne import make_executable_schema, gql
from graphql import GraphQLSchema

from bot_data.graphql.query import Query
from bot_data.graphql.server_query import ServerQuery
from bot_data.graphql.types.server_query_type import ServerQueryType


class Schema:

    def __init__(
            self,
            query: Query,
            server_query: ServerQuery,
            server_query_type: ServerQueryType
    ):
        type_defs = gql("""
            type Query {
                servers: [Server]
            }
    
            type Server {
                id: Int
                discord_id: String
            }
        """)
        self._schema = make_executable_schema(type_defs, query, server_query_type)

    @property
    def schema(self) -> GraphQLSchema:
        return self._schema
