from bot_data.abc.query_abc import QueryABC
from bot_data.graphql.query import Query
from bot_data.service.server_repository_service import ServerRepositoryService


class ServerQuery(QueryABC):

    def __init__(
            self,
            query: Query,
            servers: ServerRepositoryService
    ):
        QueryABC.__init__(self, 'servers')
        self._query = query
        self._servers = servers

        query.set_field('servers', self.resolve_servers)

    async def resolve_servers(self):
        return self._servers.get_servers()
